import QtQuick 2.0
import MuseScore 1.0

MuseScore {
      version:  "1.0"
      description: "This test plugin reverses a score"
      menuPath: "Plugins.Retrograde"

      function addNote(pitch, cursor) {
            cursor.addNote(pitch);
      }

      function generatenNewScore(name, measures, scoreNotes) {

            var numerator   = 3;
            var denominator = 4;
            var octaves     = 2;

            var score = newScore(name + ".mscz", "piano", measures);

            score.addText("title", name);
            score.addText("subtitle", "Reverted");

            var cursor = score.newCursor();
            cursor.track = 0;

            cursor.rewind(0);

            var ts = newElement(Element.TIMESIG);
            ts.setSig(numerator, denominator);
            cursor.add(ts);

            cursor.rewind(0);
            cursor.setDuration(1, denominator);
                  for (var n in scoreNotes) {
                        var d = scoreNotes[n].duration/15;
                       cursor.setDuration(d, 128);
                        var nv = scoreNotes[n].notes[0];
                        cursor.addNote(nv.pitch);
                        console.log(nv + "+")
cursor.next();
                  }
            }


function retrograde() {
            var measures = 0;
            var scoreNotes = [];

            var cursor = curScore.newCursor();
            cursor.rewind(1);
            var startStaff;
            var endStaff;
            var endTick;
            var fullScore = false;
            if (!cursor.segment) { // no selection
                  console.log("No selection")
                  fullScore = true;
                  startStaff = 0; // start with 1st staff
                  endStaff = curScore.nstaves - 1; // and end with last
                  console.log("curScore.nstaves=" + curScore.nstaves);
            } else {
                  console.log("Processing selection")
                  startStaff = cursor.staffIdx;
                  cursor.rewind(2);
                  if (cursor.tick == 0) {
                        // this happens when the selection includes
                        // the last measure of the score.
                        // rewind(2) goes behind the last segment (where
                        // there's none) and sets tick=0
                        endTick = curScore.lastSegment.tick + 1;
                  } else {
                        endTick = cursor.tick;
                  }
                  endStaff = cursor.staffIdx;
            }

            scoreNotes = [];

            console.log(startStaff + " - " + endStaff + " - " + endTick)
            for (var staff = startStaff; staff <= endStaff; staff++) {
                  for (var voice = 0; voice < 4; voice++) {
                        cursor.rewind(1); // sets voice to 0
                        cursor.voice = voice; //voice has to be set after goTo
                        cursor.staffIdx = staff;

                        if (fullScore)
                              cursor.rewind(0) // if no selection, beginning of score

                        while (cursor.segment && (fullScore || cursor.tick < endTick)) {
                              console.log(".");
                              if (cursor.element && cursor.element.type == Element.CHORD) {
                                    scoreNotes.push(cursor.element);
                              }
                              cursor.next();
                        }

                        cursor.rewind((fullScore)? 0 : 1) // if no selection, beginning of score
                        var measures = 0;
                        while (cursor.segment && (fullScore || cursor.tick < endTick)) {
                              measures++;
                              cursor.nextMeasure(measures);
                        }
                        curScore.appendMeasures(measures);
                        console.log(">>" + scoreNotes.length + ", M: " + measures);
                 }
            }
            return { "measures":measures, "scoreNotes":scoreNotes};
      }

      onRun: {
            if (typeof curScore === 'undefined')
                  Qt.quit();
            console.log("Start processing..")

            var m = {
                  measures:3, 
                  scoreNotes: [
                                          {notes:[{pitch:72}], duration:30},
                                          {notes:[{pitch:60}], duration:60}
                                    ]
                  };
           // var result = retrograde(); // line 123
            var result = m; // line 124
            console.log("measures:" + result.measures)
            for (var n in result.scoreNotes) {
                  var nv = result.scoreNotes[n].notes;
                  for (var x in nv) {
                        console.log("pitch:" + nv[x].pitch)
                        console.log("duration:" + result.scoreNotes[n].duration/15)
                  }
            }
            generatenNewScore(curScore.name, result.measures, result.scoreNotes); // line 133

            Qt.quit()
            }
      }
